<?php
namespace Teknisa\EST\Controllers;

use Teknisa\EST\Controllers\TeknisaCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

use Teknisa\EST\Services\Ger14500CustoLogisticoService;

class Ger14500CustoLogisticoController extends \Teknisa\Libs\Controller\CrudNext {

    protected $dataSourceName = '';
    protected $environment;
    protected $service;
    protected $crudService;
    protected $nameProvider;
    protected $dataSourceManager;
    
    public function __construct($crudService, $environment, $nameProvider, $dataSourceManager, Ger14500CustoLogisticoService $service) {
        $this->crudService = $crudService;
        $this->environment = $environment;
        $this->nameProvider = $nameProvider;
        $this->dataSourceManager = $dataSourceManager;
        $this->service = $service;
	}

    public function saveInMass(DTO\Request $request, DTO\Response $response) {
        try{
            
            $nextRequest = parent::buildRequest($request);
            $row = $nextRequest->getDataSet()->getRows()[0];
            
            $providers = $this->service->getProviders($row['CDFORNECED']);
            $unities = $this->service->getUnities($row['CDFILIAL'], $row['CDREGIAO']);
            $rowsToSave = $this->service->buildRows($row, $providers, $unities);
            $this->service->deleteInMass($rowsToSave);
            $this->service->saveInMass($rowsToSave);
            
            $next = new DTO\Next\Response();
            $dataSet = new DataSet("data", $rowsToSave);
            $response->addDataSet($dataSet);
            $next->setDataSet($dataSet);
            $response->setZeedhiNext($next);
        } catch(\Exception $e){
            throw $e;
        }
    }
    
    public function deleteInMass(DTO\Request $request, DTO\Response $response) {
        try{
            
            $nextRequest = parent::buildRequest($request);
            $row = $nextRequest->getDataSet()->getRows()[0];
            
            $providers = $this->service->getProviders($row['CDFORNECED']);
            $unities = $this->service->getUnities($row['CDFILIAL'], $row['CDREGIAO']);
            $rowsToSave = $this->service->buildRows($row, $providers, $unities);
            $this->service->deleteInMass($rowsToSave);
            
        } catch(\Exception $e){
            throw $e;
        }
    }
    
}