<?php
/**
 * Enter description here ...
 *
 * @package Logic
 * @author  alessandrobartels
 */
class EventoLogic {

    private $_idEvento;


    /**
     * Enter description here ...
     *
     * @param integer    $nrOrgTrab     Numero da Org. Trabalho.
     * @param integer    $nrOrgPadrao   Numero da Org. Padrao.
     * @param TkDateTime $dtIniVigencia Data de inicio de vigencia.
     * @param string     $idTipoEvento  Flag de tipo de evento.
     *
     * @throws Exception $e Propaga Excecao.
     * @return void
     */
    public function incluiEventoMestre($nrOrgTrab, $nrOrgPadrao, TkDateTime $dtIniVigencia, $idTipoEvento){

        try {
            $evento = new FpaeventomEntity(null, $nrOrgTrab, $nrOrgPadrao);

            /*   $coluna = 'NREVENTOM';
            $tabela = 'FPA_EVENTOM';
            $step = '1';
            $pk = array('NREVENTOM');
            //$param = 'NRORG = '.$nrOrgTrab;
            $this->_idEvento = GeraId::get($coluna, $tabela, $step, $pk); */
            // tk_warning('IDeve  '.$this->_idEvento);.
            $this->_idEvento = $evento->novoMestre($dtIniVigencia, $idTipoEvento);

            unset($evento);
        } catch (Exception $e) {
            throw $e;
        }

    }


    /**
     * Enter description here ...
     *
     * @param integer    $nrOrgTrab     Numero da Org. Trab.
     * @param integer    $nrOrgPadrao   Numero da Org. Padrao.
     * @param integer    $nrEvento      Numero do evento.
     * @param TkDateTime $dtIniVigencia Data de inicio de vigencia.
     * @param TkDateTime $dtFimVigencia Data de fim de vigencia.
     * @param string     $idTipoEvento  Flag de Tipo de evento.
     *
     * @return void
     */
    public function alteraEventoMestre(
        $nrOrgTrab, $nrOrgPadrao, $nrEvento, TkDateTime $dtIniVigencia, TkDateTime $dtFimVigencia, $idTipoEvento
    ){
        $evento = new FpaeventomEntity(null, $nrOrgTrab, $nrOrgPadrao);

        $obj_evento = $evento->retornaEvento($nrEvento);
        $obj_evento->setDtinivigencia($dtIniVigencia);
        $obj_evento->setDtfimvigencia($dtFimVigencia);
        $obj_evento->setIdtipoevento($idTipoEvento);
        $obj_evento->persist();
        unset($evento);
    }


    /**
     * Enter description here ...
     *
     * @return Ambigous <boolean, nreventom, NULL>
     */
    public function getNreventom(){
        return $this->_idEvento;
    }


    /**
     * Enter description here ...
     *
     * @param integer    $nrEventom      Numero do evento.
     * @param TkDateTime $mesCompetencia Mes de competencia.
     *
     * @return boolean
     */
    public function verificaEventoHistorico($nrEventom, TkDateTime $mesCompetencia){

        $eventoh = new FpaeventohEntity();
        $objEventoH = $eventoh->retornaEventoHistoricoMesCompetencia($nrEventom, $mesCompetencia);

        if (is_object($objEventoH) === true) {
            return true;
        }

        unset($eventoh);
        unset($objEventoH);
        return false;
    }


    /**
     * Enter description here ...
     *
     * @param string $idTipoEvento Flag de Tipo de evento.
     *
     * @return number
     */
    public function determinaOrdemImpressao($idTipoEvento){
        $eventoh = new FpaeventohEntity();
        $max = $eventoh->retornaMaximoOrdemImpressaoPorTipoEvento($idTipoEvento);
        return $max + 1;
    }


}